#ifndef _ENEMY_H
#define _ENEMY_H

#include "tiles.h"
#include "world.h"
#include "game.h"

#define enemyVisualRange 5
#define movementListSize 10

#define MAXTIMESTUNNED 10
#define MAXTIMESEARCH 3
#define SPEEDMOVE1 30
#define SPEEDMOVE2 25


/// Hablar sobre refactorizar cone
typedef struct 
{
    unsigned char cx, cy;	// current coordinates
    unsigned char ox, oy;	// old coordinates
}Tcone;

typedef struct Tenemy Tenemy;

struct Tenemy
{
	Tsprite base;
	Tcone coneDir[7];
	vector2 anchorPoint;
	vector2 vectorPatrolPoints[11]; //el ultimo espacio.x es para decir cuantas posiciones tiene ocupadas
	unsigned char currentState;
	unsigned char lookAt; // 0-> UP, 1-> DOWN, 2->RIGTH, 3->LEFT
	unsigned short speedMove;
	unsigned char stunTimer; 
	unsigned char searchDelay;
	unsigned char anchorDistance;
	unsigned char pointPatrol;

	unsigned char pathObjective; // si es 0 vuelve al Anchor, si es 1 su objetivo es el player
	unsigned char canMovePathF;
	TwayPoint* nearEnemy; // distancia del enemigo al waypoint mas cercano
	TwayPoint* nearEnemy2; // distancia del enemigo al segundo waypoint mas cercano
	TwayPoint* nearDestiny; // distancia del objetivo al waypoint mas cercano 	

	// Variables para Enemy2
	unsigned char waitTimer;
	unsigned char coneRestrictions;
	Tenemy *enemyHelper;



};

extern void (*moveCone[4])(Tenemy*);

void coneUp(Tenemy*);
void coneDown(Tenemy*);
void coneRight(Tenemy*);
void coneLeft(Tenemy*);

void cleanCone(Tcone*);

void drawCone(Tcone*,unsigned char);
void updateCone(Tcone*);
unsigned char detectPlayer(unsigned char, Tenemy*,unsigned char*);

void initializeEnemy(Tenemy* enemy, vector2 *patrolTpoints[11], unsigned char cx, unsigned char cy, unsigned char ox, unsigned char oy, vector2 *anchor, unsigned char anchorDistance);
void enemyAI(Tenemy*, Tplayer*);
void patrol(Tenemy*);
void follow(Tenemy*,unsigned char, unsigned char);
void attack(Tenemy*,Tplayer*);
void search(Tenemy*);


unsigned char inRange(Tenemy*, Tplayer*);
void distance(vector2*,vector2*,Tenemy*);
unsigned char move(Tenemy *,vector2 *);

void stunned(Tenemy*);
void getStunned(Tenemy *enemy);

void initWayPoints();

#endif
